<?php
/**
 * @file
 * Set up Attribute Mapping for miniOrange SAML IDP Module.
 */

 /**
 * Showing Attribute Mappping form info.
 */
 function miniorange_saml_idp_attribute_mapping($form, &$form_state) {
  global $base_url;
  
  $mo_admin_email = variable_get('miniorange_saml_idp_customer_admin_email',NULL);
  
  if(!isset($mo_admin_email)){
    $form['markup_saml_idp_regsitration_message'] = array(
	  '#markup' => '<div style="display:block;text-align: center; font-size: 15px;margin-top:10px;color:red;background-color:rgba(251, 232, 0, 0.15);'
	  . ' padding:5px;border:solid 1px rgba(255, 0, 9, 0.36);">'
	  . ' Please <a href="' . $base_url . '/?q=admin/config/people/miniorange_saml_idp">Register or Login with miniOrange</a>'
	  . ' to enable Drupal IDP.</div>'
	);
    return $form;
  }
 
  $form['markup_idp_attr_header'] = array(
    '#markup' => '<h3>Attribute Mapping(Optional)</h3><hr>',
  );
  
  $form['miniorange_saml_idp_nameid_attr_map'] = array(
    '#type' => 'select',
	'#title' => t('NameID Attribute:'),
	'#options' => array(
	  'emailAddress' => t('Drupal Email Address'),
	  'username' => t('Drupal Username'),
	),
	'#default_value' => variable_get('miniorange_saml_idp_nameid_attr_map', ''),
	'#description' => t('(<span style="color:red">NOTE:</span> This attribute value is sent in SAML Response. Users in your Service Provider<br />'
	. ' will be searched (existing users) or created (new users) based on this attribute.<br />'
	. ' Use <b>EmailAddress</b> by default.)'),
  );
  
  $form['miniorange_saml_idp_attr_map_submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save'),
    '#submit' => array('miniorange_saml_idp_save_attribute_mapping'),
  );
  
  $form['markup_idp_attr_stmt'] = array(
    '#markup' => '<br /><br /><div style="position: absolute;margin: 7% 33%;font-weight: bold;z-index: 1;"><span style="color:red;">*</span>'
	. ' This is a premium feature.'
	. ' Check<a href="' . $base_url . '/?q=admin/config/people/miniorange_saml_idp/licensing"> Licensing Tab </a>to learn' 
	. ' more.</div><div style="background-color: rgba(128, 128, 128, 0.7);padding: 2%;opacity: 0.3;">'
	. ' <h4>Attribute Statements with Group/Role Mapping (Optional)<span style="padding-left:40px;padding-right:30px;">'
	. ' <input type="button" value="+" class="btn btn-primary" style="width:30px;" disabled="true" /></span>'
	. ' <input type="button" value="-" class="btn btn-danger" style="width:30px;" disabled="true" /></h4><br />'
	. ' <span style="padding-right:235px;"><b>Name</span>User Meta Data</b><br />'
	. ' <b>NOTE:</b> These are extra attributes that will be send in the SAML Response.'
	. ' Choose <br />the User data you want to send in the Response from the dropdown. In the textbox<br />'
	. ' to the left of the dropdown give an appropriate name you want the User data mapped to.</div></div>',
  ); 
  
  return $form;

 }
 
 /**
 * Configure IdP.
 */
 function miniorange_saml_idp_save_attribute_mapping($form, &$form_state) {
  
  global $base_url;
  $mo_admin_email = variable_get('miniorange_saml_idp_customer_admin_email',NULL);
  
  if(!isset($mo_admin_email)){
    drupal_set_message(t('Please register with miniOrange to enable Drupal as IDP.'));
	drupal_goto($base_url . '/?q=admin/config/people/miniorange_saml_idp');
  }
  
  $nameid_attr = $form['miniorange_saml_idp_nameid_attr_map']['#value'];
  if($nameid_attr == ''){
    $nameid_attr = 'emailAddress';
  }
  variable_set('miniorange_saml_idp_nameid_attr_map', $nameid_attr);
  drupal_set_message(t('Your settings are saved successfully.'));
 
 }