<?php
/**
 * @file
 * Set up Identity Provide for miniOrange SAML IDP Module.
 */

 /**
 * Showing IdP Setup form info.
 */
 function miniorange_saml_idp_setup($form, &$form_state) {
  global $base_url;
  $mo_admin_email = variable_get('miniorange_saml_idp_customer_admin_email',NULL);
 
  if(!isset($mo_admin_email)){
    $form['markup_saml_idp_regsitration_message'] = array(
	  '#markup' => '<div style="display:block;margin-top:10px;text-align: center;font-size: 15px;color:red;background-color:rgba(251, 232, 0, 0.15);'
	  . ' padding:5px;border:solid 1px rgba(255, 0, 9, 0.36);">'
	  . ' Please <a href="' . $base_url . '/?q=admin/config/people/miniorange_saml_idp">Register or Login with miniOrange</a>'
	  . ' to enable Drupal IDP.</div>'
	);
    return $form;
  }
  
  $form['markup_idp_header'] = array(
    '#markup' => '<h3>Configure Identity Provider</h3><hr>',
  );
  
  $form['markup_idp_note'] = array(
    '#markup' => '<br><div>Please note down the following information from your Service Provider'
	. ' and keep it handy to configure your Identity Provider.</div>',
  );
  
  $form['markup_idp_list'] = array(
    '#markup' => '<b><ol><li>SP Entity ID / Issuer</li>'
	. ' <li>ACS URL</li>'
	. ' <li>X.509 Certificate for Signing if you are using HTTP-POST Binding. [This is a'
	. ' <a href="' . $base_url . '/?q=admin/config/people/miniorange_saml_idp/licensing">premium</a> feature]</li>'
	. ' <li>X.509 Certificate for Encryption. [This is a'
	. ' <a href="' . $base_url . '/?q=admin/config/people/miniorange_saml_idp/licensing">premium</a> feature]</li>'
	. ' <li>NameID Format</li></ol></b><br />',
  );
  
  if(!isset($mo_admin_email)){
    $form['markup_saml_idp_disabled'] = array(
      '#markup' => '<div style="position: absolute;margin: 7% 33%;font-weight: bold;z-index: 1;">'
	  . ' </div><div style="background-color: rgba(218, 218, 218, 0);padding: 2%;opacity: 0.3;">',
    );
  }
  
  $form['miniorange_saml_idp_sp_name'] = array(
    '#type' => 'textfield',
    '#title' => t('Service Provider Name'),
    '#default_value' => variable_get('miniorange_saml_idp_sp_name', ''),
    '#attributes' => array('placeholder' => 'Service Provider Name'),
    '#required' => TRUE,
  );

  $form['miniorange_saml_idp_sp_entity_id'] = array(
    '#type' => 'textfield',
    '#title' => t('SP Entity ID or Issuer'),
    '#description' => t('<b>Note:</b> You can find the EntityID in Your SP-Metadata XML file enclosed in <code>EntityDescriptor</code> tag having attribute as <code>entityID</code>.'),
    '#default_value' => variable_get('miniorange_saml_idp_sp_entity_id', ''),
    '#attributes' => array('placeholder' => 'SP Entity ID or Issuer'),
    '#required' => TRUE,
  );

 $form['miniorange_saml_idp_nameid_format'] = array(
     '#type' => 'select',
     '#title' => t('NameID Format:'),
     '#options' => array(
         '1.1:nameid-format:emailAddress' => t('urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress'),
         '1.1:nameid-format:unspecified' => t('urn:oasis:names:tc:SAML:1.1:nameid-format:unspecified'),
         '2.0:nameid-format:transient' => t('urn:oasis:names:tc:SAML:1.1:nameid-format:transient'),
         '2.0:nameid-format:persistent' => t('urn:oasis:names:tc:SAML:1.1:nameid-format:persistent'),
     ),
     '#default_value' => variable_get('miniorange_saml_idp_nameid_format', ''),
     '#description' => t('<b>Note:</b> urn:oasis:names:tc:SAML:1.1:nameid-format:emailAddress is selected by default'),
 );

  $form['miniorange_saml_idp_acs_url'] = array(
    '#type' => 'textfield',
    '#title' => t('ACS URL'),
    '#description' => t('<b>Note:</b> You can find the SAML Login URL in Your SP-Metadata XML file enclosed in <code>AssertionConsumerService </code> tag having attribute as <code>Location</code>.'),
    '#default_value' => variable_get('miniorange_saml_idp_acs_url', ''),
    '#attributes' => array('placeholder' => 'ACS URL'),
    '#required' => TRUE,
  );
  
  $form['miniorange_saml_idp_relay_state'] = array(
    '#type' => 'textfield',
    '#title' => t('Relay State'),
    '#description' => t('To identify the specific resource at the resource provider in the IDP initiated SSO. It specifes the landing page  at the service provider once SSO completes.'),
    '#attributes' => array('placeholder' => 'Relay State (optional)'),
    '#required' => FALSE,
  );


 $form['miniorange_saml_idp_x509_certificate_request'] = array(
     '#type' => 'textarea',
     '#title' => t('x.509 Certificate Value  <b>[Note: For Signed Request] </b><a href="' . $base_url . '/admin/config/people/miniorange_saml_idp/licensing"> [Premium]</a>'),
     '#cols' => '10',
     '#rows' => '5',
     '#attributes' => array('placeholder' => 'Enter x509 Certificate Value'),
     '#disabled' => TRUE,
 );


 $form['markup_1'] = array(
     '#markup' => '<b>NOTE:</b> Format of the certificate:<br><b>-----BEGIN CERTIFICATE-----<br>'
         .'XXXXXXXXXXXXXXXXXXXXXXXXXXX<br>-----END CERTIFICATE-----</b><br><br>'
 );

 $form['miniorange_saml_idp_x509_certificate_assertion'] = array(
     '#type' => 'textarea',
     '#title' => t('x.509 Certificate Value <b>[Note: For Encrypted Assertion]</b> <a href="' . $base_url . '/admin/config/people/miniorange_saml_idp/licensing"> [Premium]</a>'),
     '#cols' => '10',
     '#rows' => '5',
     '#attributes' => array('placeholder' => 'Enter x509 Certificate Value'),
     '#disabled' => TRUE,
 );


 $form['markup_2'] = array(
     '#markup' => '<b>NOTE:</b> Format of the certificate:<br><b>-----BEGIN CERTIFICATE-----<br>'
         .'XXXXXXXXXXXXXXXXXXXXXXXXXXX<br>-----END CERTIFICATE-----</b><br><br><br>'
 );

 $form['miniorange_saml_idp_response_signed'] = array(
     '#markup' => '<br>',
     '#type' => 'checkbox',
     '#title' => t('Response Signed <b>[This is a Premium feature]</b>'
         . ' Check <a href="' . $base_url . '/admin/config/people/miniorange_saml_idp/licensing"><b>Licensing</b></a>'
         . ' Tab to learn more.'),
     '#disabled' => TRUE,
 );


 $form['miniorange_saml_idp_encrypt_signed'] = array(
     '#type' => 'checkbox',
     '#title' => t('Encrypted Assertion <b>[This is a Premium feature]</b>'
         . ' Check <a href="' . $base_url . '/admin/config/people/miniorange_saml_idp/licensing"><b>Licensing</b></a>'
         . ' Tab to learn more.'),
     '#disabled' => TRUE,
 );

  $form['miniorange_saml_idp_assertion_signed'] = array(
    '#type' => 'checkbox',
    '#title' => t('Assertion Signed (Check If you want to sign SAML Assertion)'),
    '#required'=>FALSE,
    '#default_value' => variable_get('miniorange_saml_idp_assertion_signed', FALSE),
  );

  $form['markup_idp_attr_br'] = array(
    '#markup' => '<br><br>',
  );

  $form['miniorange_saml_idp_config_submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save Configuration'),
    '#submit' => array('miniorange_saml_idp_save_idp_config'),
  );

  $form['miniorange_saml_idp_test_config_button'] = array(
    '#markup' => '<a class="btn btn-primary btn-large" style="padding:3px 7px;  margin-right: 14px;" onclick="testIdpConfig(\'' . getTestUrl() . '\');">'
    . 'Test Configuration</a>'
  );

  $acs_url = variable_get('miniorange_saml_idp_acs_url', '');
  $entity_id = variable_get('miniorange_saml_idp_sp_entity_id', '');
  $disable_val = ($acs_url == '' || is_null($acs_url) || $entity_id == '' || is_null($entity_id))? TRUE : FALSE;

  $form['miniorange_saml_idp_config_delete'] = array(
    '#type' => 'submit',
    '#value' => t('Delete Configuration'),
    '#submit' => array('miniorange_saml_idp_delete_idp_config'),
    '#disabled' => $disable_val,
  );

  return $form;
 }

 function getTestUrl() {
  global $base_url;
  $issuer = variable_get('miniorange_saml_idp_sp_entity_id');
  $acs = variable_get('miniorange_saml_idp_acs_url');
  $testUrl = $base_url . '/?q=mo_testIdpConfig';

  return $testUrl; 
 }

 /**
 * Configure IdP.
 */
 function miniorange_saml_idp_save_idp_config($form, &$form_state) {
  global $base_url;
  $mo_admin_email = variable_get('miniorange_saml_idp_customer_admin_email',NULL);
  
  if(!isset($mo_admin_email)){
    drupal_set_message(t('Please register with miniOrange to enable Drupal as IDP.'));
	drupal_goto($base_url . '/?q=admin/config/people/miniorange_saml_idp');
  }
  
  $sp_name = $form['miniorange_saml_idp_sp_name']['#value'];
  $issuer = $form['miniorange_saml_idp_sp_entity_id']['#value'];
  $acs_url = $form['miniorange_saml_idp_acs_url']['#value'];
  $relay_state = $form['miniorange_saml_idp_relay_state']['#value'];
  $nameid_format = $form['miniorange_saml_idp_nameid_format']['#value'];
  $is_assertion_signed = $form['miniorange_saml_idp_assertion_signed']['#value'] == 1 ? TRUE : FALSE;
  
  variable_set('miniorange_saml_idp_sp_name', $sp_name);
  variable_set('miniorange_saml_idp_sp_entity_id', $issuer);
  variable_set('miniorange_saml_idp_acs_url', $acs_url);
  variable_set('miniorange_saml_idp_relay_state', $relay_state);
  variable_set('miniorange_saml_idp_nameid_format', $nameid_format);
  variable_set('miniorange_saml_idp_assertion_signed', $is_assertion_signed);
  
  drupal_set_message(t('Your Service Provider Configuration are successfully saved. You can click on Test Configuration button below to test these configurations.'));

 }
 
 function miniorange_saml_idp_delete_idp_config($form, &$form_state){
  variable_set('miniorange_saml_idp_sp_name', '');
  variable_set('miniorange_saml_idp_sp_entity_id', '');
  variable_set('miniorange_saml_idp_acs_url', '');
  variable_set('miniorange_saml_idp_relay_state', '');
  variable_set('miniorange_saml_idp_nameid_format', '');
  variable_set('miniorange_saml_idp_assertion_signed', '');
  
  drupal_set_message(t('Your Service Provider Configuration is successfully deleted.'));
  }